using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace Monodoc {
	public class Settings {
		#region Loading/Saving
		static string settingsFile;
		static XmlSerializer settingsSerializer = new XmlSerializer (typeof (Settings));
		static Settings Instance;
		
		static Settings ()
		{
			// >>> HACK HACK HACK
			// Kepp this only until we get Environment working right
			string rootDir = Environment.GetEnvironmentVariable ("XDG_CONFIG_HOME");
			if (rootDir == null || rootDir == "")
				rootDir = Path.Combine (Environment.GetEnvironmentVariable ("HOME"), ".config");
			// <<< HACK HACK HACK
			
			SettingsPath = Path.Combine (rootDir, "monodoc");
			settingsFile = Path.Combine (SettingsPath, "settings.xml");
			if (File.Exists (settingsFile))
				Instance = (Settings) settingsSerializer.Deserialize (new XmlTextReader (settingsFile));
			else
				Instance = new Settings ();
		}

		public static void Save ()
		{
			EnsureSettingsDirectory ();
			settingsSerializer.Serialize (File.Create (settingsFile), Instance);
		}
		
		// these can be used for other types of settings too
		public static string SettingsPath;
		public static void EnsureSettingsDirectory ()
		{
			DirectoryInfo d = new DirectoryInfo (SettingsPath);
			if (!d.Exists)
				d.Create ();
		}
		
		#endregion
		
		// public to allow serialization
		public bool enableEditing = true;

		// Last serial number commited
		public int SerialNumber = 0;

		public string Email;
		public string Key;
		
		public static bool EnableEditing {
			get {
				return Instance.enableEditing;
			}
			set {
				if (Instance.enableEditing != value) {
					Instance.enableEditing = value;
					Save ();
				}
			}
		}
	}
}
